/*------------------------------------------------------------------------------- 
Code to receive with a ADSP-21062 link port(5) from a ADSP-21160. The DSP's I/O 
processor manages the DMA transfer through the link port. The DMA operation transfers
and stores an entire block of data in DM data memory. 
-------------------------------------------------------------------------------*/

#include	"def21060.h"

#define N 512			/* lenght of receive data */

/*------------ DM data --------------*/
.section/dm seg_dmda;
.var dest[N];

/*---- PM interrupt vector code -----*/
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;

/*------ program memory code -------*/
.section/pm seg_pmco;

start:  ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
		bit clr ustat1 0x800; 
		dm(SYSCON) = ustat1;

setup:	r0=0;			/* Clear Link Control Registers */
		dm(LCTL)=r0;
		dm(LAR)=r0;

						/* Set up DMA pointers */
		r0=dest;
		dm(II4)=r0;		/* Set DMA channel 4 Index Register */
	
		r0=1;
		dm(IM4)=r0;		/* Set DMA channel 4 Modify Register */

		r0=@dest;		
		dm(C4)=r0;		/* Set DMA channel 4 count Register */

		r0=0x0000000;	/* receive at clock frequency */
		dm(LCOM)=r0;
	
		r0=0x3ff7f;		
		dm(LAR)=r0;		/* LBUF2 <==> LPORT5, all others disabled */

		r9=0x00000300;	
		dm(LCTL)=r9;	/* lbuf2 enable, receive, 32-bit word, 4-bit bus width, DMA */
			
/* terminate and wait */
wait1: 
jump wait1;
/*-----------------------------------------------------------------------------*/
