/*------------------------------------------------------------------------------- 
Code to transmit with a ADSP-21062 link port(5) to a ADSP-21160. The core directly 
writes N values to the link buffer(LBUF2). The core stops writing words to the buffer,
if the L2STAT1 bit indicates a full condition. 
-------------------------------------------------------------------------------*/

#include	"def21060.h"

#define N 1024

/*------------ DM data --------------*/
.section/dm seg_dmda;


/*---- PM interrupt vector code -----*/
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;

/*------ program memory code -------*/
.section/pm seg_pmco;

start:	ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
		bit clr ustat1 0x800; 
		dm(SYSCON) = ustat1;

setup:	r0=0x00000000;			
		dm(LCTL)=r0;			/* clear link control registers */
		dm(LAR)=r0;
	
		r0=0x0000000; 			/* Lclk2x=0 */
		dm(LCOM)=r0;

		r0=0x3ff7f;				/* LBUF2 <==> LPORT5, all others disabled */
		dm(LAR)=r0;

		r9=0x00000900;			/* lbuf2 enable, transmit, 32-bit word, 4-bit bus width */
		dm(LCTL)=r9;			/* always write LCTLx after LAR */
		r2=N;				

readstat:
		ustat1=dm(LCOM);		/* read Link Port common Control Register */
		bit tst ustat1 0x20;		
		if tf jump readstat;	/* test until buffer is empty */
		if GT jump readstat (DB);
		dm(LBUF2)=r2;			/* write value to link port buffer */
		r2=r2-1;
			
/* terminate and wait */

wait1:	idle;
		jump wait1;
/*-----------------------------------------------------------------------------*/
.ENDSEG;
